Bug 532044 - php fails to build on ARM because of an alignment error
Summary: php fails to build on ARM because of an alignment error
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: php
Version: 12
Hardware: arm9
OS: Linux
low
medium
Target Milestone: ---
Assignee: Joe Orton
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: ARMTracker
TreeView+ depends on / blocked
 
Reported: 2009-10-30 12:49 UTC by Kedar Sovani
Modified: 2010-12-04 03:36 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2010-12-04 03:36:02 UTC


Attachments (Terms of Use)
proposed fix (481 bytes, patch)
2009-10-30 12:52 UTC, Kedar Sovani
no flags Details | Diff

Description Kedar Sovani 2009-10-30 12:49:32 UTC
When the "php" binary is executed to create phar.php, an alignment error is encountered thus causing the build to fail.

Comment 1 Kedar Sovani 2009-10-30 12:52:10 UTC
Created attachment 366794 [details]
proposed fix

proposed fix

Comment 2 Joe Orton 2009-10-30 13:48:46 UTC
-	(z)->value = (v)->value; \
+	memcpy(&(z)->value, &(v)->value, sizeof((z)->value)); \

those are logically equivalent in C, surely?  Where's the alignment issue occurring with the use of this macro?

Comment 3 Jitesh Shah 2009-10-30 15:51:08 UTC
If (z)->value or (v)->value is improperly aligned, the first statement will fault. But, memcpy falls back to a byte-by-byte copy, thus, eliminating any unaligned accesses.

Comment 4 Kedar Sovani 2009-10-30 16:07:46 UTC
http://lecs.cs.ucla.edu/wiki/index.php/XScale_alignment
http://netwinder.osuosl.org/users/b/brianbr/public_html/alignment.html#q3

ARM expects pointers/words are aligned on word boundary. The pointer values that are passed to this assignment are now aligned on such a boundary, thus causing the problems. 

Here is the failed log:
http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=75564

Here is the successful build after applying this patch:
http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=75686

Comment 5 Bug Zapper 2009-11-16 14:41:04 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 6 Bug Zapper 2010-11-04 06:58:50 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 7 Bug Zapper 2010-12-04 03:36:02 UTC
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.